remove some out of date autotools pieces from dmapi tests
[xfstests-dev.git] / 012
1 #! /bin/sh
2 # FS QA Test No. 012
3 #
4 # holes
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2001 Silicon Graphics, Inc.  All Rights Reserved.
8
9 # This program is free software; you can redistribute it and/or modify it
10 # under the terms of version 2 of the GNU General Public License as
11 # published by the Free Software Foundation.
12
13 # This program is distributed in the hope that it would be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
16
17 # Further, this software is distributed without any warranty that it is
18 # free of the rightful claim of any third person regarding infringement
19 # or the like.  Any license provided herein, whether implied or
20 # otherwise, applies only to this software file.  Patent licenses, if
21 # any, provided herein do not apply to combinations of this program with
22 # other software, or any other product whatsoever.
23
24 # You should have received a copy of the GNU General Public License along
25 # with this program; if not, write the Free Software Foundation, Inc., 59
26 # Temple Place - Suite 330, Boston MA 02111-1307, USA.
27
28 # Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
29 # Mountain View, CA  94043, or:
30
31 # http://www.sgi.com 
32
33 # For further information regarding this notice, see: 
34
35 # http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
36 #-----------------------------------------------------------------------
37 #
38 # creator
39 owner=dxm@sgi.com
40
41 seq=`basename $0`
42 echo "QA output created by $seq"
43
44 here=`pwd`
45 tmp=/tmp/$$
46 status=0        # success is the default!
47 trap "_cleanup; exit \$status" 0 1 2 3 15
48
49 _cleanup()
50 {
51     cd /
52     rm -f $tmp.*
53     rm -rf $testdir/holes.$$.*
54     _cleanup_testdir
55 }
56
57 _filesize()
58 {
59     ls -l $1 | $AWK_PROG '{print "    filesize = " $5}'
60 }
61
62 # get standard environment, filters and checks
63 . ./common.rc
64 . ./common.filter
65
66 _do_test()
67 {
68     _n="$1"
69     _param="$2"
70     _count="$3"
71     
72     failed=0
73     
74     out=$testdir/holes.$$.$_n
75     echo ""
76     echo "holes.$_n : $_param"
77     echo "-----------------------------------------------"
78     if  ! $here/src/holes $_param $out >$tmp.out
79     then
80         echo "    holes returned $? - see $seq.out.full"
81         failed=1
82         status=1
83     fi
84         
85
86     if [ $failed -eq 0 ]
87     then        
88         # quick check - how many holes did we get?
89         count=`xfs_bmap $out | egrep -c ': hole'`
90         echo "    $count hole(s) detected"
91         # and how big was the file?
92         _filesize $out
93         
94         if [ $count -ne $_count ]
95         then
96             echo "    unexpected number of holes - see $seq.out.full"
97             status=1
98             failed=1
99         fi
100     fi
101         
102     if [ $failed -eq 1 ]
103     then
104         echo "--------------------------------------"       >>$here/$seq.out.full
105         echo "$_n - output from holes:"                     >>$here/$seq.out.full
106         echo "--------------------------------------"       >>$here/$seq.out.full
107         cat $tmp.out                                        >>$here/$seq.out.full
108         echo "--------------------------------------"       >>$here/$seq.out.full
109         echo "$_n - output from bmap:"                      >>$here/$seq.out.full
110         echo "--------------------------------------"       >>$here/$seq.out.full
111         xfs_bmap -vvv $out                                  >>$here/$seq.out.full
112         echo "--------------------------------------"       >>$here/$seq.out.full
113         echo "$_n - output from ls -li:"                    >>$here/$seq.out.full
114         echo "--------------------------------------"       >>$here/$seq.out.full
115         ls -li $out                                         >>$here/$seq.out.full
116         status=1
117     fi
118 }
119
120 # real QA test starts here
121 _supported_fs xfs
122 _supported_os IRIX Linux
123
124 _setup_testdir
125
126 rm -f $here/$seq.out.full
127
128 # small & fairly dense
129 _do_test 1 "-l 40960000 -b 40960 -i 10 -c 1" 100
130
131 # big & sparse
132 _do_test 2 "-l 409600000 -b 40960 -i 1000 -c 1" 10
133
134 # no holes, but a very nasty way to write a file (lots of extents)
135 _do_test 3 "-l 40960000 -b 40960 -i 10 -c 10" 0
136
137 exit